/* @creatblProd_DATE.sql */
SET ECHO ON

/* Crear las tablas y aadir algunas restricciones, de varias maneras
*/
CREATE TABLE Suministradores (
  rfSum    CHAR(3),
  nombSum  CHAR(20) CONSTRAINT NN_nSumin NOT NULL,
  NIF      CHAR(10) CONSTRAINT UN_NIF_S  UNIQUE,
  ciudad   CHAR(12));
ALTER  TABLE Suministradores ADD    (CONSTRAINT PK_Sumin PRIMARY KEY (rfSum));
ALTER  TABLE Suministradores MODIFY (NIF CONSTRAINT NN_NIF_S  NOT NULL);

CREATE TABLE Piezas (
  rfPza    CHAR(4)   CONSTRAINT PK_Piezas   PRIMARY KEY,
  nombPza  CHAR(14)  CONSTRAINT NN_nPieza   NOT NULL,
  color    CHAR(10),
  peso     NUMBER(2),
  ciudad   CHAR(12));

CREATE TABLE Proyectos (
  rfProy   CHAR(3),
  nombProy CHAR(20) CONSTRAINT NN_nProy NOT NULL,
  ciudad   CHAR(12),
  CONSTRAINT PK_Proy PRIMARY KEY (rfProy));

CREATE TABLE SuminPiezasProy (
  rfSum  CHAR(3)  CONSTRAINT FK_SP_Sum REFERENCES Suministradores(rfSum),
  rfPza  CHAR(4),
  rfProy CHAR(3),
  cant  NUMBER (3),
  CONSTRAINT FK_SP_Pza  FOREIGN KEY (rfPza)  REFERENCES Piezas(rfPza),
  CONSTRAINT FK_SP_Proy FOREIGN KEY (rfProy) REFERENCES Proyectos(rfProy));

DESCRIBE Suministradores;
DESCRIBE Piezas;
DESCRIBE Proyectos;
DESCRIBE SuminPiezasProy;
